<?php

namespace Tests\Feature\Http\Requests;

use App\Http\Requests\UserCreateRequest;
use App\Models\Position;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Foundation\Testing\WithFaker;
use Illuminate\Http\UploadedFile;
use Illuminate\Support\Facades\Validator;
use Tests\TestCase;

class UserCreateRequestTest extends TestCase
{
    use WithFaker, RefreshDatabase;

    private $formRequest;

    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        $this->formRequest = new UserCreateRequest();
    }

    /**
     * @return void
     */
    public function test_rules_successful()
    {
        Position::factory(1)->create();

        $data = $this->provideSuccessfulData();
        $validator = Validator::make($data, $this->formRequest->rules());
        $this->assertTrue($validator->passes());

    }

    /**
     * @dataProvider provideInvalidNameData
     * @return void
     */
    public function test_rule_name_fail(array $data)
    {
        Position::factory(1)->create();

        $validator = Validator::make($data, $this->formRequest->rules());
        $this->assertFalse($validator->passes());

    }

    public function provideInvalidNameData()
    {
        $data = $this->provideSuccessfulData();
        return [
            [array_merge(
                $data,
                ['name' => str_repeat('a', UserCreateRequest::NAME_MAX_LENGTH + 1)]
            )], // long name
            [array_merge(
                $data,
                ['name' => str_repeat('a', UserCreateRequest::NAME_MIN_LENGTH - 1)]
            )], // short name
            [array_merge($data, ['name' => null])], // empty name
        ];
    }

    /**
     * @dataProvider provideInvalidEmailData
     * @return void
     */
    public function test_rule_email_fail(array $data)
    {
        Position::factory(1)->create();

        $validator = Validator::make($data, $this->formRequest->rules());
        $this->assertFalse($validator->passes());

    }

    public function provideInvalidEmailData()
    {
        $data = $this->provideSuccessfulData();
        return [
            [array_merge(
                $data,
                ['email' => '@example.com']
            )], // wrong email
            [array_merge($data, ['email' => null])], // empty email
        ];
    }

    /**
     * @dataProvider provideInvalidPhoneData
     * @return void
     */
    public function test_rule_phone_fail(array $data)
    {
        Position::factory(1)->create();

        $validator = Validator::make($data, $this->formRequest->rules());
        $this->assertFalse($validator->passes());

    }

    public function provideInvalidPhoneData()
    {
        $data = $this->provideSuccessfulData();
        return [
            [array_merge(
                $data,
                ['phone' => '180501234567']
            )], // wrong code
            [array_merge(
                $data,
                ['phone' => '3805012345678']
            )], // long phone
            [array_merge(
                $data,
                ['phone' => '38050123456']
            )], // short phone
            [array_merge($data, ['phone' => null])], // empty phone
        ];
    }

    /**
     * @dataProvider provideInvalidPositionData
     * @return void
     */
    public function test_rule_position_fail(array $data)
    {
        Position::factory(1)->create();

        $validator = Validator::make($data, $this->formRequest->rules());
        $this->assertFalse($validator->passes());

    }

    public function provideInvalidPositionData()
    {
        $data = $this->provideSuccessfulData();
        return [
            [array_merge(
                $data,
                ['position_id' => 2]
            )], // wrong position_id, currently has only one position with id 1
            [array_merge(
                $data,
                ['position_id' => -1]
            )], // wrong position_id
            [array_merge($data, ['position_id' => null])], // empty position
        ];
    }

    /**
     * @dataProvider provideInvalidPhotoData
     * @return void
     */
    public function test_rule_photo_fail(array $data)
    {
        Position::factory(1)->create();

        $validator = Validator::make($data, $this->formRequest->rules());
        $this->assertFalse($validator->passes());

    }

    public function provideInvalidPhotoData()
    {
        $data = $this->provideSuccessfulData();
        return [
            [array_merge(
                $data,
                [
                    'photo' => UploadedFile::fake()
                        ->image(
                            'avatar.jpg',
                            UserCreateRequest::IMAGE_MIN_WIDTH,
                            UserCreateRequest::IMAGE_MIN_HEIGHT
                        )
                    ->size(UserCreateRequest::IMAGE_MAX_SIZE + 1)
                ]
            )], // wrong size
            [array_merge(
                $data,
                [
                    'photo' => UploadedFile::fake()
                        ->image(
                            'avatar.jpg',
                            UserCreateRequest::IMAGE_MIN_WIDTH,
                            UserCreateRequest::IMAGE_MIN_HEIGHT - 1
                        )
                ]
            )], // wrong height
            [array_merge(
                $data,
                [
                    'photo' => UploadedFile::fake()
                        ->image(
                            'avatar.jpg',
                            UserCreateRequest::IMAGE_MIN_WIDTH - 1,
                            UserCreateRequest::IMAGE_MIN_HEIGHT
                        )
                ]
            )], // wrong width
            [array_merge(
                $data,
                [
                    'photo' => UploadedFile::fake()
                        ->image(
                            'avatar.png',
                            UserCreateRequest::IMAGE_MIN_WIDTH,
                            UserCreateRequest::IMAGE_MIN_HEIGHT
                        )
                ]
            )], // wrong mime type
            [array_merge(
                $data,
                ['photo' => UploadedFile::fake()->create('avatar.tmp', 2000, 'text/plain')]
            )], // not image
            [array_merge($data, ['photo' => null])], // empty photo
        ];
    }

    private function provideSuccessfulData()
    {
        return [
            'name' => str_repeat('a', UserCreateRequest::NAME_MIN_LENGTH),
            'email' => 'demo@example.com',
            'phone' => '+380501234567',
            'position_id' => 1,
            'photo' => UploadedFile::fake()->image(
                'avatar.jpg',
                UserCreateRequest::IMAGE_MIN_WIDTH,
                UserCreateRequest::IMAGE_MIN_HEIGHT
            ),
        ];
    }
}
